local mPhotonView,mJavaBridge = ...

function init()

    local main_title = Rapid:getData('main_title')
    local sub_title = Rapid:getData('sub_title')

    local uni_pop_type = Rapid:getData('uni_pop_type')
    if uni_pop_type == '1' then
        local rubbish_cache_size = mJavaBridge:getFormatRubbishCacheSize()
        local feature_title = string.format(main_title, "<font color='#f3b200'>"..rubbish_cache_size.."</font>")
        Rapid:setData('main_feature_title', feature_title)
        Rapid:setData('sub_feature_title', sub_title)
    else
        Rapid:setData('main_feature_title', main_title)
        Rapid:setData('sub_feature_title', sub_title)
    end

    local button_text = Rapid:getData('button_text')
    if button_text == nil or button_text == "" then
        Rapid:getChild('go_forward'):setAttr('visibility', 'gone')
    else
        Rapid:getChild('go_forward'):setAttr('visibility', 'visible')
    end
end

function resolveText(content)
    local dialogSelf = Rapid:getData("self")
    if dialogSelf ~= nil then
        return dialogSelf:resolveText(content)
    end
    return content
end

function doGoForward()
    local button_click_action = Rapid:getData('button_click_action')
    local dialogSelf = Rapid:getData("self")
    if dialogSelf ~= nil then
        dialogSelf:executeClickAction(button_click_action)
    end
end

function onPageOut(stayDuration)
    local actionRunner = mPhotonView:getParser():getTaskCenter():getActionRunner()
    local params1 = {}
    params1["param"] = "scene:data@uni_pop_scene,sourcescene:2000,slotid:-1_-1,actionid:2005,subposition:-1,modeltype:-1"
    params1["extendparam"] = "report_element:page,stay_duration:"..stayDuration
    actionRunner:run("reportaction", params1, nil)
end

function onDismiss(dismissType)
    local actionRunner = mPhotonView:getParser():getTaskCenter():getActionRunner()
    local params1 = {}
    params1["param"] = "scene:data@uni_pop_scene,sourcescene:2000,slotid:99_001,actionid:201,subposition:001,modeltype:data@modeltype"
    params1["extendparam"] = "report_element:pop,uni_popid:data@uni_popid,uni_pop_type:data@uni_pop_type,uni_pop_configid:data@uni_pop_configid,uni_monitor_event_code:data@uni_monitor_event_code,uni_cancel_type:"..dismissType
    params1["recommendid"] = "data@R1"
    actionRunner:run("reportaction", params1, nil)
end